require "savon"

module NfseCarioca
  class Client
    def call(method, object)
      if NfseCarioca.configuration.fake_mode
        NfseCarioca::FakeResponse.new method, object
      else
        payload = client.call(method, message: { inputXML: object.to_xml })
        object.class::Response.new payload
      end
    end

    private

    def client
      Savon.client({
        wsdl: NfseCarioca.configuration.wsdl,
        env_namespace: :soap,
        namespace_identifier: nil,
        element_form_default: :unqualified,
        ssl_verify_mode: :none,
        ssl_version: :SSLv3,
        ssl_cert_file: NfseCarioca.configuration.cert_path,
        ssl_cert_key_file: NfseCarioca.configuration.cert_key_path,
        ssl_ca_cert_file: NfseCarioca.configuration.ca_cert_path,
        ssl_cert_key_password: NfseCarioca.configuration.cert_key_password,
        log_level: NfseCarioca.configuration.log_level,
        log: true,
        open_timeout: 120,
        read_timeout: 120
      })
    end
  end
end
