module NfseCarioca
  class Configuration

    attr_accessor :test_mode,
                  :fake_mode,
                  :log_level,
                  :ca_cert_path,
                  :cert_key_path,
                  :cert_path,
                  :cert_key_password,
                  :cnpj,
                  :inscricao_municipal,
                  :codigo_municipio,
                  :rps_serie,
                  :rps_tipo,
                  :rps_natureza_operacao,
                  :rps_optante_simples_nacional,
                  :rps_incentivador_cultural,
                  :iss_retido,
                  :valor_aliquota,
                  :valor_pis,
                  :valor_cofins,
                  :valor_inss,
                  :valor_ir,
                  :valor_csll,
                  :valor_iss,
                  :item_lista_servico,
                  :codigo_tributacao_municipio

    def initialize
      @fake_mode = false
      @test_mode = false
      @log_level = :error

      @codigo_municipio = "3304557"
      @rps_serie = "A"
      @rps_tipo = 1
      @rps_natureza_operacao = 1
      @rps_optante_simples_nacional = 1
      @rps_incentivador_cultural = 2

      @iss_retido = 2
      @valor_aliquota = 0
      @valor_pis = 0
      @valor_cofins = 0
      @valor_inss = 0
      @valor_ir = 0
      @valor_csll = 0
      @valor_iss = 0

      @item_lista_servico = "0105"
      @codigo_tributacao_municipio = "010501"
    end

    def wsdl
      if test_mode
        "https://homologacao.notacarioca.rio.gov.br/WSNacional/nfse.asmx?wsdl"
      else
        "https://notacarioca.rio.gov.br/WSNacional/nfse.asmx?wsdl"
      end
    end

  end
end
