require "nfse_carioca/gerar_nfse_xml"
require "nfse_carioca/fake_response"

module NfseCarioca
  class GerarNfse
    def initialize(invoice)
      @invoice = invoice
    end

    def execute!
      client.call(:gerar_nfse, self)
    end

    def to_xml
      GerarNfseXML.new(@invoice).to_xml
    end

    private
    def client
      NfseCarioca::Client.new
    end

    class Response < NfseCarioca::Response
      def number
        content["CompNfse"]["Nfse"]["InfNfse"]["Numero"] if success?
      end

      def verification_code
        content["CompNfse"]["Nfse"]["InfNfse"]["CodigoVerificacao"] if success?
      end

      def errors
        if error?
          message = content["ListaMensagemRetorno"]["MensagemRetorno"]
          message = [message] if message.is_a?(Hash)

          message
        end
      rescue
        content
      end
    end
  end
end
